//04_09_19 Joerg Homberger

import java.util.Random;


public class Problem{
	
	// problembezogene Daten
	static int n;							//Anzahl Standorte zugleich Anzahl Gene
	static int m;							//Anzahl Kunden
	static int[]   f;   					//Fixkosten
	static int[][] t;						//Transportkosten

	// verfahrensbezogene Daten
	static double pm; 						//Mutationswahrscheinlichkeit

	
	
	

	public static void erzeugenInstanz(int anzahlStandorte, int anzahlKunden, int maxWert){
		n    = anzahlStandorte;
		m    = anzahlKunden;
		f    = new int[n];
		t    = new int[n][m];
		
		
		int  seed = 5;
		Random r = new Random(seed);
		
		
		/*
		 * z.B. f mit n=2 Standorten
		 * 70
		 * 80
		 * z.B. Errichtung von Standort kostet 70 Geldeinheiten 
		 */
		
		/* z.B. t mit n=2 Standorten und m=3 Kunden
		 * 10 20 30
		 * 15 70 80
		 * z.B. die Belieferung von Kunde 3 von Standort 2 kostet 80 Geldeinheiten
		 */

		 //Fixkosten im Intervall [0, maxWert] erzeugen
		 for(int i=0;i<n;i++){
			 f[i] = r.nextInt()%(maxWert+1);
			 if(f[i]<0)f[i] = -f[i];
		 }
		//Transportkosten im Intervall [0, maxWert] erzeugen
		 for(int i=0;i<n;i++){
			 for(int j=0;j<m;j++){
				 t[i][j] = r.nextInt()%(maxWert+1);
				 if(t[i][j]<0)t[i][j] = -t[i][j];
			 }			 
		 }
		 
		 for(int i=0;i<n;i++){
			 System.out.print("Standort: " + i + " -> Fixkosten: " + f[i] + "        Transportkosten zu den Orten 0 bis " + (m-1) + " :   ");
			 for(int j=0;j<m;j++){
				 System.out.print(t[i][j] + " ");
			 }
			 System.out.println();
		 }
		 
		 
	}

	
	
	
	
	
	public static void ausgabeKosten(int[][] t, int[] f) {
		System.out.println("Transportkosten:");		
		for(int i=0;i<t.length;i++) {
			for(int j=0;j<t[i].length;j++) {
				System.out.print(t[i][j] + " "); 
			}
			System.out.println();
		}
		
		System.out.println("Fixkosten:");
		for(int i=0;i<t.length;i++) {
			System.out.println(f[i]); 
		}
		System.out.println("-------------------------------");
		
	}		
	
	
	public static void initialisierung() {
		//Anzahl der Gene werden problemspezifisch festgelegt
		for(int i=0;i<Ablauf.POP.length;i++){
			Ablauf.POP[i] = new int[n];
			Ablauf.POPCHILD[i] = new int[n];
		}
		Ablauf.BEST = new int[n];
		pm = 1.0/n;           //Mutationswahrscheinlichkeit
		
		randomPop();
	}

	public static void randomPop() {

		for (int i = 0; i < Ablauf.POP.length; i++) {
			for (int s = 0; s < Ablauf.POP[i].length; s++) {
				int anz = 0;
				if (Math.random() < 0.5) {
					Ablauf.POP[i][s] = 0;
				} else {
					Ablauf.POP[i][s] = 1;
					anz++;
				}

				if (anz == 0) {
					int spalte = (int) (m * Math.random());// spalte ist kleiner als n
					Ablauf.POP[i][spalte] = 1;
				}
			}
		}
	}
	
	
	
	
	public static void crossover(int child1, int child2, int eltern1, int eltern2) {
		int trenner = (int) (Ablauf.POP[0].length * Math.random()); // Zufllige Lnge fuer crossover
		for (int j = 0; j < trenner; j++) {
			Ablauf.POPCHILD[child1][j] = Ablauf.POP[eltern1][j];
			Ablauf.POPCHILD[child2][j] = Ablauf.POP[eltern2][j];
		}
		for (int j = trenner; j < Ablauf.POP[0].length; j++) {
			Ablauf.POPCHILD[child1][j] = Ablauf.POP[eltern2][j];
			Ablauf.POPCHILD[child2][j] = Ablauf.POP[eltern1][j];
		}
	}
	public static void swapMutation(int child) {
		int pos1 = (int) (Ablauf.POP[0].length * Math.random());
		int pos2 = (int) (Ablauf.POP[0].length * Math.random());
		int tmp  = Ablauf.POPCHILD[child][pos1];
		Ablauf.POPCHILD[child][pos1] = Ablauf.POPCHILD[child][pos2];
		Ablauf.POPCHILD[child][pos2] = tmp;
	}
	public static void flipMutation(int child) {
		boolean zulaessig = false;
		for(int j=0;j<Ablauf.POP[0].length;j++) {
			double zz = Math.random();
			if(zz<pm) {
				if(Ablauf.POPCHILD[child][j] == 0)	Ablauf.POPCHILD[child][j]=1;
				else 					   			Ablauf.POPCHILD[child][j]=0;
			}
			if(Ablauf.POPCHILD[child][j] == 1)zulaessig = true;
		}
		if(!zulaessig){
			int standort = (int)(m*Math.random());
			Ablauf.POPCHILD[child][standort] = 1;
		}
		
		
	}
	public static int fitness(int[] indi) {
		int fit = 0;
		int standort;
		boolean[] standorte = new boolean[n];		//mit false intitialisiert
		
		//Transportkosten
		for (int k = 0; k < t[0].length; k++) {
			int min  = Integer.MAX_VALUE;
			standort = 0;
			for (int s = 0; s < indi.length; s++) {
				if (indi[s] == 1) {
					if (t[s][k] < min) {
						min = t[s][k];
						standort = s;
					}
				}
			}
			standorte[standort] = true;
			fit += min;
			//System.out.println(k + "--- " + fit );
		}
		//System.out.println();
		
		//Fixkosten fr gewhlte (!) Standorte
		for (int s = 0; s < indi.length; s++) {
			if (standorte[s]) {
				fit += f[s];
			}
			//System.out.println(s + " " + standorte[s] + " --- " + fit );
		}
		
		
		
		return fit;
	}

	public static void loesungAusgeben(int[] indi) {
		//es wird Zuordnung von Kunden zu Standorten ausgegeben
		int standort;

		System.out.println();
		System.out.println("BESTE LOESUNG: ");
		System.out.println("Kunde Standort");
		
		
		//Zuordnung berechnen
		for (int k = 0; k < t[0].length; k++) {
			int min  = Integer.MAX_VALUE;
			standort = 0;
			for (int s = 0; s < indi.length; s++) {
				if (indi[s] == 1) {
					if (t[s][k] < min) {
						min = t[s][k];
						standort = s;
					}
				}
			}
			System.out.println(k + " " + standort);
		}
	}
	
}
